VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CodeDoc"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

'This file is part of the ASP Code Documenter project.
'Copyright (C) 2001 Balaji Srinivasan <vinylrecord@yahoo.com>
'@see http://vinylrecord.tripod.com

'This program is free software; you can redistribute it and/or modify
'it under the terms of the GNU General Public License as published by
'the Free Software Foundation; either version 2 of the License, or
'(at your option) any later version.

'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.

'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Const COMMENT_CHAR = "'"
Const OUTPUT_NEWLINE_CHARS = vbNewLine

Dim colLines As New Collection

'All these functions assume that they are working with a single file at a time.
'All use the global colLines variable.

Public Function GetFunctions(oMethods As Methods)

Dim cLine As String
Dim iOffSet As Long, iCounter As Long
Dim cMethodName As String
Dim cComments As String

'Can't use for..each since we need the key too.
For iCounter = 1 To colLines.Count
    Dim cProperCaseLine As String
    cProperCaseLine = colLines.Item(iCounter)
    cLine = LCase(colLines.Item(iCounter))
    
    iOffSet = InStr(cLine, "public function")
    If (iOffSet = 0) Then
        iOffSet = InStr(cLine, "private function")
    End If
    If (iOffSet = 0) Then
        iOffSet = InStr(cLine, "public sub")
    End If
    If (iOffSet = 0) Then
        iOffSet = InStr(cLine, "private sub")
    End If
    
    
    If iOffSet <> 0 Then
        'cMethodName = Mid(cLine, iOffSet)
        cMethodName = Mid(cProperCaseLine, iOffSet)
        
        Dim iNoOfLinesInMethodName As Long
        iNoOfLinesInMethodName = 1
        
        Dim iTmpMethodCounter As Long
        iTmpMethodCounter = iCounter
        
        If Mid(cMethodName, Len(cMethodName)) = "_" Then
            'The function name is continued in the next line
            cMethodName = cMethodName + colLines.Item(iCounter + 1)
        End If
        
        Dim cTmpMethodName As String
        cTmpMethodName = "xyz"
        Do While cTmpMethodName <> ""
            iTmpMethodCounter = iTmpMethodCounter + 1
            cTmpMethodName = colLines.Item(iTmpMethodCounter)
            If Mid(cTmpMethodName, Len(cTmpMethodName)) = "_" Then
                'The function name is continued in the next line
                cMethodName = cMethodName + cTmpMethodName
            Else
                If iNoOfLinesInMethodName = 1 Then
                    cMethodName = cMethodName
                Else
                    cMethodName = cMethodName + cTmpMethodName
                End If
                Exit Do
            End If
            iNoOfLinesInMethodName = iNoOfLinesInMethodName + 1
        Loop
        
        cComments = GetFunctionComments(iCounter)
        ParseMethodComments cComments, cMethodName, oMethods
        
    End If
Next iCounter

End Function

Public Function ParseMethodComments(cComments As String, cMethodName As String, ByRef oMethods As Methods) As Collection

'Method properties
Dim cMethodDescription As String
Dim cExample As String
Dim oParameters As New Parameters

Dim cReturnValue As String
Dim cSince As String

Dim cUsage As String
Dim cAuthor As String
Dim cVersion As String

Dim iOffSet As Integer
Dim iNextOffSet As Integer

Dim cCommentLine As String
Dim cCommentLineValue As String

iOffSet = 1
Do While iOffSet <> 0

    'iOffSet = InStr(cComments, vbNewLine & "@")
    iOffSet = InStr(cComments, "'@")
    
    'MsgBox cComments
    
    If iOffSet = 0 Then
        Exit Do
    End If

    iNextOffSet = InStr(iOffSet + 1, cComments, "'@")
    If iNextOffSet <> 0 Then
        cCommentLine = Mid(cComments, iOffSet, iNextOffSet - iOffSet)
    Else
        'Last Line
        cCommentLine = Mid(cComments, iOffSet)
    End If
    'MsgBox cCommentLine
    cComments = Mid(cComments, iOffSet + 1)
    
    
    Dim cCommentType As String
    Dim iCommentTypeOffSet As Integer
    iCommentTypeOffSet = InStr(cCommentLine, " ")
    
    cCommentType = Mid(cCommentLine, 1, iCommentTypeOffSet)
    
    cCommentType = RemoveSpecialChars(cCommentType)
    
    cCommentType = Mid(cCommentType, 2)
    
    
    
    
    cCommentLineValue = cCommentLine
        
    Dim iValueOffSet As Integer
    
    iValueOffSet = InStr(cCommentLine, "@")
    iValueOffSet = InStr(iValueOffSet, cCommentLine, " ")
    
    If iValueOffSet <> 0 Then
        cCommentLineValue = Trim(Mid(cCommentLine, iValueOffSet))
    Else
        cCommentLineValue = Trim(cCommentLine)
    End If
    
    
    If cCommentType = "@desc" Then
        cMethodDescription = cCommentLineValue
    End If
    
    If cCommentType = "@example" Then
        cExample = cCommentLineValue
    End If
    
    If cCommentType = "@return" Then
        cReturnValue = cCommentLineValue
    End If
    
    If cCommentType = "@since" Then
        cSince = cCommentLineValue
    End If
    
    If cCommentType = "@usage" Then
        cUsage = cCommentLineValue
    End If
    
    If cCommentType = "@author" Then
        cAuthor = cCommentLineValue
    End If
    
    If cCommentType = "@version" Then
        cVersion = cCommentLineValue
    End If
    
    If cCommentType = "@param" Then
        'Dim oParameter As New Parameter
        Dim cParameterName As String
        Dim cParameterDescription As String
        Dim iParamOffSetStart As Integer
        
        
        cCommentLineValue = Replace(cCommentLineValue, COMMENT_CHAR, OUTPUT_NEWLINE_CHARS)
        cCommentLineValue = Replace(cCommentLineValue, vbTab, " ")
        
        iParamOffSetStart = InStr(cCommentLineValue, " ")
                
        If iParamOffSetStart <> 0 Then
            cParameterName = Mid(cCommentLineValue, 1, iParamOffSetStart)
            cParameterDescription = Mid(cCommentLineValue, iParamOffSetStart + 1)
        Else
            cParameterName = cCommentLineValue
        End If
        'Dim iParamOffSetEnd As Integer
        
        'iParamOffSetStart = InStr(cCommentLine, vbTab)
        'iParamOffSetEnd = InStr(iParamOffSetStart + 1, cCommentLine, vbTab)
        
        'cParameterName = Mid(cCommentLine, iParamOffSetStart, iParamOffSetEnd - iParamOffSetStart)
        
        
        
        oParameters.Add cParameterName, cParameterDescription
    End If
    
    
    
Loop

Dim oMethod As Method


'Replace comment char with output newline char
cMethodName = Replace(cMethodName, COMMENT_CHAR, OUTPUT_NEWLINE_CHARS)
cMethodDescription = Replace(cMethodDescription, COMMENT_CHAR, OUTPUT_NEWLINE_CHARS)
cExample = Replace(cExample, COMMENT_CHAR, OUTPUT_NEWLINE_CHARS)
cReturnValue = Replace(cReturnValue, COMMENT_CHAR, OUTPUT_NEWLINE_CHARS)
cSince = Replace(cSince, COMMENT_CHAR, OUTPUT_NEWLINE_CHARS)
cUsage = Replace(cUsage, COMMENT_CHAR, OUTPUT_NEWLINE_CHARS)
cAuthor = Replace(cAuthor, COMMENT_CHAR, OUTPUT_NEWLINE_CHARS)
cVersion = Replace(cVersion, COMMENT_CHAR, OUTPUT_NEWLINE_CHARS)

Set oMethod = oMethods.Add(cMethodName, cMethodDescription, cExample, oParameters, cReturnValue, cSince, cUsage, cAuthor, cVersion)


End Function

Public Function GetFunctionComments(iLineNo As Long) As String

GetFunctionComments = GetPrevComments(iLineNo)

GetFunctionComments = GetFunctionComments + GetNextComments(iLineNo, False)

End Function


Public Function GetPrevComments(iLineNo As Long) As String
Dim cLine 'As variant
Dim iOffSet As Integer, iCounter As Integer
Dim cComments As String

'Check previous lines till first non commented blank, ignoring blank lines
For iCounter = iLineNo - 1 To 1 Step -1

    cLine = RemoveSpecialChars(colLines.Item(iCounter))

    If Mid(cLine, 1, 1) = COMMENT_CHAR Then
        cComments = cLine + " " + cComments + " "
    Else
        If cLine <> "" Then
            Exit For
        End If
    End If
Next iCounter

GetPrevComments = cComments
End Function


Public Function RemoveSpecialChars(cString As String) As String

    cString = Trim(cString)
    
    cString = Replace(cString, vbLf, " ")
    cString = Replace(cString, vbNewLine, " ")
    
    cString = Replace(cString, Chr$(10), " ")
    cString = Replace(cString, Chr$(34), " ")
    
    cString = Replace(cString, vbTab, " ")
    cString = Trim(cString)

    RemoveSpecialChars = cString

End Function

Public Function GetNextComments(iLineNo As Long, bDeepSearch As Boolean) As String
Dim cLine 'As variant
Dim iOffSet As Integer, iCounter As Integer
Dim cComments As String

'if bDeepSearch is true, then
'we want to find for the comments, and even ignore blank lines.
'This is needed for VB forms, since the comments appear after a lot of junk
'contain form layout information.

Dim bFirstCommentFound As Boolean
bFirstCommentFound = False
'Check next lines till first non commented blank, ignoring blank lines
For iCounter = iLineNo + 1 To colLines.Count
    
    cLine = Trim(colLines.Item(iCounter))
    cLine = Replace(cLine, vbLf, " ")
    'cLine = Replace(cLine, vbNewLine, "")
    cLine = Replace(cLine, vbTab, " ")
    cLine = Trim(cLine)
    
    
    If Mid(cLine, 1, 1) = COMMENT_CHAR Then
        cComments = cComments + cLine + " "
        bFirstCommentFound = True
    Else
        If cLine <> "" Then
            If bDeepSearch = False Then
                Exit For
            Else
                'Check if we have found any comments..
                'exit only after we have found a comment
                If bFirstCommentFound = True Then
                    Exit For
                End If
            End If
        End If
    End If
Next iCounter

GetNextComments = cComments

End Function

Public Sub getFileComments(cFileName As String, ByRef oFileMethods As Methods)
Dim cFileComments As String


cFileComments = GetNextComments(1, True)

'New Stuff
'Dim cLine 'As variant
'Dim iOffSet As Integer, iCounter As Integer
'Dim cComments As String
'
'Dim iLineNo As Integer
'Dim bFirstCommentFound As Boolean
'iLineNo = 1
''Check next lines till first non commented blank, ignoring blank lines
'For iCounter = iLineNo + 1 To colLines.Count
'
'    cLine = Trim(colLines.Item(iCounter))
'    cLine = Replace(cLine, vbLf, " ")
'    'cLine = Replace(cLine, vbNewLine, "")
'    cLine = Replace(cLine, vbTab, " ")
'    cLine = Trim(cLine)
'
'
'    If Mid(cLine, 1, 1) = COMMENT_CHAR Then
'        cComments = cComments + cLine + " "
'        bFirstCommentFound = True
'    Else
'        If cLine <> "" Then
'            If bFirstCommentFound = True Then
'                Exit For
'            End If
'        End If
'    End If
'Next iCounter
'
'cFileComments = cComments
'End Of New Stuff


'MsgBox cFileComments
ParseMethodComments cFileComments, cFileName, oFileMethods
End Sub

Public Function ReadFileIntoCollection(cFileName As String)
Dim bMore As Boolean
Dim cInput As String

cInput = LoadFileIntoBuffer(cFileName)

'Reinit
Set colLines = Nothing
Set colLines = New Collection

Dim iLastPos As Integer
Dim iLineNo As Long

iLineNo = 1

iLastPos = 1
Do While True

    Dim iCurrPos As Integer
    iCurrPos = InStr(cInput, vbNewLine)
    
    If iCurrPos = 0 Then
        Exit Do
    End If
    
    colLines.Add Mid(cInput, iLastPos, iCurrPos - iLastPos), CStr(iLineNo)
    
    iLineNo = iLineNo + 1
    
    cInput = Mid(cInput, iCurrPos + 1)

Loop

End Function


