Attribute VB_Name = "modForms"
Option Explicit

'This file is part of the ASP Code Documenter project.
'Copyright (C) 2001 Balaji Srinivasan <vinylrecord@yahoo.com>
'@see http://vinylrecord.tripod.com

'This program is free software; you can redistribute it and/or modify
'it under the terms of the GNU General Public License as published by
'the Free Software Foundation; either version 2 of the License, or
'(at your option) any later version.

'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.

'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Public Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpSectionName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Public Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpSectionName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long

Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long

Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cY As Long, ByVal wFlags As Long) As Long
' SetWindowPos Flags
Public Const SWP_NOSIZE = &H1
Public Const SWP_NOMOVE = &H2
Public Const SWP_NOZORDER = &H4
Public Const SWP_NOREDRAW = &H8
Public Const SWP_NOACTIVATE = &H10
Public Const SWP_FRAMECHANGED = &H20        '  The frame changed: send WM_NCCALCSIZE
Public Const SWP_SHOWWINDOW = &H40
Public Const SWP_HIDEWINDOW = &H80
Public Const SWP_NOCOPYBITS = &H100
Public Const SWP_NOOWNERZORDER = &H200      '  Don't do owner Z ordering

Public Const SWP_DRAWFRAME = SWP_FRAMECHANGED
Public Const SWP_NOREPOSITION = SWP_NOOWNERZORDER

' SetWindowPos() hwndInsertAfter values
Public Const HWND_TOP = 0
Public Const HWND_BOTTOM = 1
Public Const HWND_TOPMOST = -1
Public Const HWND_NOTOPMOST = -2

Global Const COLUMNS_FORM_NAME = "Columns"
'Global Const COLUMNS_FORM_CLASS = "ThunderRT65FormDC"
Global Const COLUMNS_FORM_CLASS = "ThunderFormDC"

'Public Declare Function GetClassName Lib "user32" Alias "GetClassNameA" (ByVal hwnd As Long, ByVal lpClassName As String, ByVal nMaxCount As Long) As Long

Public Function SetFormOnTop(frmForm As Form, bOnTop As Boolean)
With frmForm
  If bOnTop Then
    SetWindowPos .hwnd, HWND_TOPMOST, .Left / Screen.TwipsPerPixelY, _
      .Top / Screen.TwipsPerPixelX, .Width / Screen.TwipsPerPixelY, _
      .Height / Screen.TwipsPerPixelX, SWP_NOACTIVATE Or SWP_SHOWWINDOW
  Else
    SetWindowPos .hwnd, HWND_NOTOPMOST, .Left / Screen.TwipsPerPixelY, _
      .Top / Screen.TwipsPerPixelX, .Width / Screen.TwipsPerPixelY, _
      .Height / Screen.TwipsPerPixelX, SWP_NOACTIVATE Or SWP_SHOWWINDOW
  End If
End With
End Function


