Attribute VB_Name = "modASPCodeDocumenter"
Option Explicit

'This file is part of the ASP Code Documenter project.
'Copyright (C) 2001 Balaji Srinivasan <vinylrecord@yahoo.com>
'@see http://vinylrecord.tripod.com

'This program is free software; you can redistribute it and/or modify
'it under the terms of the GNU General Public License as published by
'the Free Software Foundation; either version 2 of the License, or
'(at your option) any later version.

'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.

'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.



Public Function GenerateHTMLReportFormat1(cSourceFile As String) As String
Dim oFileMethods As New Methods

Dim oMethods As New Methods
Dim cOutput As String
Dim cNewLine As String

Dim oCodeDoc As New CodeDoc

oCodeDoc.ReadFileIntoCollection (cSourceFile)

oCodeDoc.GetFunctions oMethods
oCodeDoc.getFileComments cSourceFile, oFileMethods

cNewLine = "<br>" & vbNewLine
cOutput = "<html>" '& cNewLine

Dim cTitle As String

Dim oFso As New FileSystemObject
Dim oFile As File

Dim oFileMethod As Method
For Each oFileMethod In oFileMethods
    
    Set oFile = oFso.GetFile(oFileMethod.MethodName)
    'Do this only the 1st time. this code should execute the first thing inside the loop
    If cTitle = "" Then
    cOutput = cOutput & "<head>" & "<title>"
    cOutput = cOutput & oFile.Name
    cOutput = cOutput & "</title>"
    
    cOutput = cOutput & "<style type=""text/css"">"
    cOutput = cOutput & "<!--"
    cOutput = cOutput & "h2 {  font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 14pt}"
    cOutput = cOutput & "p {  font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 10pt}"
    cOutput = cOutput & "tr {  font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 10pt}"
    cOutput = cOutput & "body {  font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 10pt}"
    cOutput = cOutput & "-->"
    cOutput = cOutput & "</style>"
    
    cOutput = cOutput & "</head>" & cNewLine
    
    cOutput = cOutput & GetSetting(App.ProductName, "Config", "Header", "")
    End If
    
    cOutput = cOutput & "<h2>" & oFile.Name & "</h2>" & cNewLine
    cOutput = cOutput & oFileMethod.Description & cNewLine
    
    Dim oFileParameters As Parameters
    Set oFileParameters = oFileMethod.Parameters
    Dim oFileParameter As Parameter
    
    If oFileParameters.Count <> 0 Then
        cOutput = cOutput & "<h4>Parameters</h4>" & cNewLine
        cOutput = cOutput & "<table border= 1 width=100%>"
        cOutput = cOutput & "<tr><td bgcolor=""#CCCCCC""><strong>Parameter</strong></td><td bgcolor=""#CCCCCC""><strong>Description</strong></td></tr>"
        For Each oFileParameter In oFileParameters
            cOutput = cOutput & "<tr>"
            cOutput = cOutput & "<td>" & oFileParameter.ParameterName & "</td>"
            cOutput = cOutput & "<td>" & oFileParameter.ParameterDescription & "</td>"
            cOutput = cOutput & "</tr>"
        Next
        cOutput = cOutput & "</table>"
    Else
        cOutput = cOutput & "<h4>Parameters</h4> None"
    End If
    
    cOutput = cOutput & cNewLine

    cOutput = cOutput & "<strong>Return Value</strong>&nbsp;" & oFileMethod.ReturnValue & cNewLine
    'cOutput = cOutput & "<strong>Since</strong>&nbsp;" & oFileMethod.Since & cNewLine
    cOutput = cOutput & "<strong>Author</strong>&nbsp;" & oFileMethod.Author & cNewLine
    cOutput = cOutput & "<strong>Version</strong>&nbsp;" & oFileMethod.Version & cNewLine
    
    cOutput = cOutput & "<strong>Example</strong>" & cNewLine
    cOutput = cOutput & oFileMethod.Example & cNewLine
    cOutput = cOutput & cNewLine & cNewLine
Next



'Methods
Dim oMethod As Method
For Each oMethod In oMethods
    
    cOutput = cOutput & "<h3>Method: " & oMethod.MethodName & "</h3>" & cNewLine
    cOutput = cOutput & oMethod.Description & cNewLine
    cOutput = cOutput & "<h4>Parameters</h4>" & cNewLine
    
    Dim oParameters As Parameters
    Set oParameters = oMethod.Parameters
    Dim oParameter As Parameter
    
    cOutput = cOutput & "<table border= 1 width=100%>"
    cOutput = cOutput & "<tr><td bgcolor=""#CCCCCC""><strong>Parameter</strong></td><td bgcolor=""#CCCCCC""><strong>Description</strong></td></tr>"
    
    For Each oParameter In oParameters
        cOutput = cOutput & "<tr>"
        cOutput = cOutput & "<td>" & oParameter.ParameterName & "</td>"
        
        cOutput = cOutput & "<td>" & oParameter.ParameterDescription & "</td>"
    
        cOutput = cOutput & "</tr>"
    Next

    cOutput = cOutput & "</table>"
    cOutput = cOutput & cNewLine

    cOutput = cOutput & "<strong>Return Value</strong>&nbsp;" & oMethod.ReturnValue & cNewLine
    cOutput = cOutput & "<strong>Since</strong>&nbsp;" & oMethod.Since & cNewLine
    cOutput = cOutput & "<strong>Usage</strong>&nbsp;" & oMethod.Usage & cNewLine
    cOutput = cOutput & "<strong>Example</strong>" & cNewLine
    cOutput = cOutput & oMethod.Example & cNewLine
    cOutput = cOutput & cNewLine & cNewLine
Next

cOutput = cOutput & "<hr>"
cOutput = cOutput & GetSetting(App.ProductName, "Config", "Footer", "")
cOutput = cOutput & "</html>"

GenerateHTMLReportFormat1 = cOutput

End Function

Public Function LoadFileIntoBuffer(cFileName As String) As String
If cFileName = "" Then Exit Function

On Error GoTo ErrHand

Dim oFso As New FileSystemObject
Dim oFile As File
Dim oTextStream As TextStream
Set oFile = oFso.GetFile(cFileName)
Set oTextStream = oFile.OpenAsTextStream(ForReading)
LoadFileIntoBuffer = oTextStream.ReadAll
oTextStream.Close
Exit Function

ErrHand:

MsgBox cFileName & vbNewLine & Err.Number & " : " & Err.Description, vbExclamation

End Function

Public Sub SaveFile(cFileName As String, cData As String)
On Error GoTo ErrHand



Dim oFso As New FileSystemObject
Dim oFile As File

Dim oTextStream As TextStream


Set oTextStream = oFso.CreateTextFile(cFileName, True)

'Set oFile = oFso.GetFile(cFileName)


'= oFile.OpenAsTextStream(ForWriting)

oTextStream.Write cData
oTextStream.Close


Exit Sub

ErrHand:
MsgBox Err.Description
Resume
End Sub






